unit fFunc00001;

interface

uses Classes, Graphics, fFunc, GL, Glut;

type
	TfrmFunc00001 = class(TfrmFunc)
  public
  	Angle: Integer;
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

implementation

{ TfrmFunc00001 }

procedure TfrmFunc00001.glDraw;
begin
  Angle := (Angle + 1) mod 360;
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glLoadIdentity;
  glRotatef(-Angle, 1, 2, 3);
  glBegin(GL_TRIANGLES);
    glColor3f(1, 0, 0);   glVertex2f(-0.7, -0.7);
    glColor3f(0, 1, 0);   glVertex2f(0.7, -0.7);
    glColor3f(0, 0, 1);   glVertex2f(0, 0.7);
  glEnd;
	FContext.PageFlip;  
end;

procedure TfrmFunc00001.glInit;
begin
	Angle := 0;
	glEnable(GL_DEPTH_TEST);
end;

procedure TfrmFunc00001.glResize;
begin
	if Assigned(FContext) then glViewport(0, 0, FP.Width, FP.Height);
end;

end.
