unit fFunc00055;

interface

uses fFuncNeHe, OpenGL, GL;

type
	TfrmFunc00055 = class(TfrmFuncNeHe)
  public
    procedure glDraw; override;
  end;

var
  rtri: GLfloat = 0;
  rquad: GLfloat = 0;

implementation

{ TfrmFunc00055 }

procedure TfrmFunc00055.glDraw;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);  // Smae obrazovku a hloubkov buffer

  glLoadIdentity();	                                    // Reset matice
  glTranslatef(-1.5,0.0,-6.0);                          // Posun doleva a do hloubky
  glRotatef(rtri,0.0,1.0,0.0);                          // Oto trojhelnk okolo osy y
  glBegin(GL_TRIANGLES);                                // Zatek kreslen trojhelnk
    glColor3f(1.0,0.0,0.0);                             // erven barva
    glVertex3f( 0.0, 1.0, 0.0);                         // Horn bod
    glColor3f(0.0,1.0,0.0);                             // Zelen barva
    glVertex3f(-1.0,-1.0, 0.0);                         // Lev doln bod
    glColor3f(0.0,0.0,1.0);                             // Modr barva
    glVertex3f( 1.0,-1.0, 0.0);                         // Prav doln bod
  glEnd();                                              // Ukonen kreslen trojhelnk

  glLoadIdentity();                                     // Reset matice
  glTranslatef(1.5,0.0,-6.0);                           // Posun potku
  glRotatef(rquad,1.0,0.0,0.0);                         // Pootoen tverce okolo osy x
  glColor3f(0.5,0.5,1.0);                               // Svtle modr barva
  glBegin(GL_QUADS);                                    // Zatek kreslen obdlnk
    glVertex3f(-1.0, 1.0, 0.0);                         // Lev horn bod
    glVertex3f( 1.0, 1.0, 0.0);                         // Prav horn bod
    glVertex3f( 1.0,-1.0, 0.0);                         // Prav doln bod
    glVertex3f(-1.0,-1.0, 0.0);                         // Lev doln bod
  glEnd();                                              // Konec kreslen obdlnk

  FContext.PageFlip;

  rtri := rtri + 0.3;                                   // Inkrementace hlu pootoen trojhelnku
  rquad := rquad - 0.3;                                // Inkrementace hlu pootoen tverce

end;

end.

