unit fFunc00056;

interface

uses fFuncNeHe, OpenGL, GL;

type
	TfrmFunc00056 = class(TfrmFuncNeHe)
  public
    procedure glDraw; override;
  end;

var
  rtri: GLfloat = 0;
  rquad: GLfloat = 0;
  
implementation

{ TfrmFunc00056 }

procedure TfrmFunc00056.glDraw;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);  // Smae obrazovku a hloubkov buffer

  glLoadIdentity();	                                    // Reset matice
  glTranslatef(-1.5,0.0,-6.0);                          // Posun doleva a do hloubky
  glRotatef(rtri,0.0,1.0,0.0);                          // Oto trojhelnk okolo osy y
  glBegin(GL_triangles);                                // Zatek kreslen pyramidy
    glColor3f(1.0,0.0,0.0);                             // erven
    glVertex3f( 0.0, 1.0, 0.0);                         // Horn bod (eln stna)
    glColor3f(0.0,1.0,0.0);                             // Zelen
    glVertex3f(-1.0,-1.0, 1.0);                         // Lev spodn bod (eln stna)
    glColor3f(0.0,0.0,1.0);                             // Modr
    glVertex3f( 1.0,-1.0, 1.0);                         // Prav spodn bod (eln stna)

    glColor3f(1.0,0.0,0.0);                             // erven
    glVertex3f( 0.0, 1.0, 0.0);                         // Horn bod (prav stna)
    glColor3f(0.0,0.0,1.0);                             // Modr
    glVertex3f( 1.0,-1.0, 1.0);                         // Lev bod (prav stna)
    glColor3f(0.0,1.0,0.0);                             // Zelen
    glVertex3f( 1.0,-1.0, -1.0);                        // Prav bod (prav stna)

    glColor3f(1.0,0.0,0.0);                             // erven
    glVertex3f( 0.0, 1.0, 0.0);                         // Horn bod (zadn stna)
    glColor3f(0.0,1.0,0.0);                             // Zelen
    glVertex3f( 1.0,-1.0, -1.0);                        // Lev bod (zadn stna)
    glColor3f(0.0,0.0,1.0);                             // Modr
    glVertex3f(-1.0,-1.0, -1.0);                        // Prav bod (zadn stna)

    glColor3f(1.0,0.0,0.0);                             // erven
    glVertex3f( 0.0, 1.0, 0.0);                         // Horn bod (lev stna)
    glColor3f(0.0,0.0,1.0);                             // Modr
    glVertex3f(-1.0,-1.0,-1.0);                         // Lev bod (lev stna)
    glColor3f(0.0,1.0,0.0);                             // Zelen
    glVertex3f(-1.0,-1.0, 1.0);                         // Prav bod (lev stna)
  GlEnd();                                              // Konec kreslen pyramidy

  glLoadIdentity();                                     // Reset matice
  glTranslatef(1.5,0.0,-7.0);                           // Posun potku
  glRotatef(rquad,1.0,1.0,1.0);                         // Pootoen tverce okolo osy x
  glBegin(GL_QUADS);                                    // Zatek kreslen krychle
    glColor3f(0.0,1.0,0.0);                             // Zelen
    glVertex3f( 1.0, 1.0,-1.0);                         // Prav horn (horn stna)
    glVertex3f(-1.0, 1.0,-1.0);                         // Lev horn (horn stna)
    glVertex3f(-1.0, 1.0, 1.0);                         // Lev doln (horn stna)
    glVertex3f( 1.0, 1.0, 1.0);                         // Prav doln (horn stna)

    glColor3f(1.0,0.5,0.0);                             // Oranov
    glVertex3f( 1.0,-1.0, 1.0);                         // Prav horn bod (spodn stna)
    glVertex3f(-1.0,-1.0, 1.0);                         // Lev horn (spodn stna)
    glVertex3f(-1.0,-1.0,-1.0);                         // Lev doln (spodn stna)
    glVertex3f( 1.0,-1.0,-1.0);                         // Prav doln (spodn stna)

    glColor3f(1.0,0.0,0.0);                             // erven
    glVertex3f( 1.0, 1.0, 1.0);                         // Prav horn (eln stna)
    glVertex3f(-1.0, 1.0, 1.0);                         // Lev horn (eln stna)
    glVertex3f(-1.0,-1.0, 1.0);                         // Lev doln (eln stna)
    glVertex3f( 1.0,-1.0, 1.0);                         // Prav doln (eln stna)

    glColor3f(1.0,1.0,0.0);                             // lut
    glVertex3f( 1.0,1.0,-1.0);                          // Prav horn (zadn stna)
    glVertex3f(-1.0,1.0,-1.0);                          // Lev horn (zadn stna)
    glVertex3f(-1.0,-1.0,-1.0);                         // Lev doln (zadn stna)
    glVertex3f( 1.0,-1.0,-1.0);                         // Prav doln (zadn stna)

    glColor3f(0.0,0.0,1.0);                             // Modr
    glVertex3f(-1.0, 1.0, 1.0);                         // Prav horn (lev stna)
    glVertex3f(-1.0, 1.0,-1.0);                         // Lev horn (lev stna)
    glVertex3f(-1.0,-1.0,-1.0);                         // Lev doln (lev stna)
    glVertex3f(-1.0,-1.0, 1.0);                         // Prav doln (lev stna)

    glColor3f(1.0,0.0,1.0);                             // Fialov
    glVertex3f( 1.0, 1.0,-1.0);                         // Prav horn (prav stna)
    glVertex3f( 1.0, 1.0, 1.0);                         // Lev horn (prav stna)
    glVertex3f( 1.0,-1.0, 1.0);                         // Lev doln (prav stna)
    glVertex3f( 1.0,-1.0,-1.0);                         // Prav doln (prav stna)
  glEnd();                                              // Konec kreslen krychle

  rtri := rtri + 0.2;                                   // Inkrementace hlu pootoen trojhelnku
  rquad := rquad - 0.15;                                // Inkrementace hlu pootoen tverce

  FContext.PageFlip;
  
end;

end.

