unit fFunc00064;

interface

uses Classes, Graphics, fFunc, OpenGL, GL, Glut;

type
	TfrmFunc00064 = class(TfrmFunc)
  public
  	Angle: Integer;
    procedure glInit; override;
    procedure glDraw; override;
		procedure glResize; override;
  end;

implementation

{ TfrmFunc00064 }

procedure TfrmFunc00064.glDraw;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  glLoadIdentity;
  glRotatef(Angle, 1, 1, 1);
  glutWireTorus(0.3, 0.6, 16, 32);
  Angle := (Angle+1) mod 360;
  FContext.PageFlip;
end;

procedure TfrmFunc00064.glInit;
begin
	Angle := 0;
	glEnable(GL_DEPTH_TEST);
end;

procedure TfrmFunc00064.glResize;
begin
	if Assigned(FContext) then
  	glViewport(0, 0, FP.Width, FP.Height);
end;

end.

