unit fFunc00006;//Example 2-5

interface

uses fFunc, fUtils, OpenGL, GL;

type
	TfrmFunc00006 = class(TfrmFunc)
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

implementation

{ TfrmFunc00006 }

procedure TfrmFunc00006.glDraw;
var
	I: Integer;
begin
	glClear(GL_COLOR_BUFFER_BIT);
  glColor3f(1,1,1);
  glEnable(GL_LINE_STIPPLE);

  glLineStipple(1, $0101);	DrawOneLine(50,125,150,125);//dotted
  glLineStipple(1, $00FF);  DrawOneLine(150,125,250,125);//dashed
  glLineStipple(1, $1C47);  DrawOneLine(250,125,350,125);//dash-dot-dash

	glLineWidth(5);
  glLineStipple(1, $0101);	DrawOneLine(50,100,150,100);//dotted
  glLineStipple(1, $00FF);  DrawOneLine(150,100,250,100);//dashed
  glLineStipple(1, $1C47);  DrawOneLine(250,100,350,100);//dash-dot-dash
  glLineWidth(1);

  glLineStipple(1, $1C47);
  glBegin(GL_LINE_STRIP);
	  for I := 0 to 6 do
  		glVertex2f(50+I*50, 75);
  glEnd();

  for I := 0 to 5 do
  	DrawOneLine(50+I*50,50,50+(I+1)*50,50);

  glLineStipple(5, $1C47);
  DrawOneLine(50,25,350,25);

  glDisable(GL_LINE_STIPPLE);


  //Culling Polygon
  glPolygonMode(GL_FRONT, GL_FILL);
  glPolygonMode(GL_BACK, GL_LINE);
  glFrontFace(GL_CCW);
//  glEnable(GL_CULL_FACE);
//  glCullFace(GL_FRONT);

  for I := 0 to 2 do//CCW
  begin
  	case I of
    	0: glColor3f(1,0,0);
      1: glColor3f(0,1,0);
      2: glColor3f(0,0,1);
    end;

	  glBegin(GL_POLYGON);
  	  glVertex2f(050+110*I,200);
  	  glVertex2f(050+110*I,300);
	    glVertex2f(150+110*I,300);
    	glVertex2f(150+110*I,200);
  	glEnd();

	  glBegin(GL_POLYGON);
  	  glVertex2f(050+110*I,320);
    	glVertex2f(150+110*I,320);
	    glVertex2f(150+110*I,420);
  	  glVertex2f(050+110*I,420);
  	glEnd();

  end;

  glFlush();
  FContext.PageFlip;

end;

procedure TfrmFunc00006.glInit;
begin
	glClearColor(0,0,0,0);
  glShadeModel(GL_FLAT);
end;

procedure TfrmFunc00006.glResize;
var
	w, h: GLfloat;
begin
	inherited;
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  w := FP.ClientWidth;
  h := FP.ClientHeight;
  glOrtho(0,w,0,h,-1,1);
end;


end.

